Package io.vertx.reactivex.core.http

## Class ClientWebSocket

- java.lang.Object
- - io.vertx.reactivex.core.http.WebSocket
  - - io.vertx.reactivex.core.http.ClientWebSocket

- All Implemented Interfaces:
    `WebSocketBase`, `ReadStream<Buffer>`, `StreamBase`, `WriteStream<Buffer>`

      public class ClientWebSocket
      extends WebSocket

  Represents a client-side WebSocket.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<ClientWebSocket>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ClientWebSocket​(ClientWebSocket delegate)` |
    `ClientWebSocket​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `String` | `binaryHandlerID()` | When a `WebSocket` is created, it may register an event handler with the event bus - the ID of that handler is given by this method.
    `ClientWebSocket` | `binaryMessageHandler​(Handler<Buffer> handler)` | Set a binary message handler on the connection.
    `Future<Void>` | `close()` | Close the WebSocket sending the default close frame.
    `Future<Void>` | `close​(short statusCode)` | Close the WebSocket sending a close frame with specified status code.
    `Future<Void>` | `close​(short statusCode, String reason)` | Close sending a close frame with specified status code and reason.
    `ClientWebSocket` | `closeHandler​(Handler<Void> handler)` | Set a close handler.
    `String` | `closeReason()` | Returns the close reason message from the remote endpoint or `null` when not yet received.
    `Short` | `closeStatusCode()` | Returns the close status code received from the remote endpoint or `null` when not yet received.
    `Future<WebSocket>` | `connect​(int port, String host, String requestURI)` | Connect this WebSocket to the specified port, host and relative request URI.
    `Future<WebSocket>` | `connect​(WebSocketConnectOptions options)` | Connect this WebSocket with the specified options.
    `Future<WebSocket>` | `connect​(String requestURI)` | Connect this WebSocket at the relative request URI using the default host and port.
    `Future<WebSocket>` | `connect​(String host, String requestURI)` | Connect this WebSocket to the host and relative request URI and default port.
    `ClientWebSocket` | `drainHandler​(Handler<Void> handler)` | Set a drain handler on the stream.
    `Future<Void>` | `end()` | Calls `WebSocketBase.close()`
    `Future<Void>` | `end​(Buffer data)` | Same as `WebSocketBase.end(io.vertx.core.buffer.Buffer)` but writes some data to the stream before ending.
    `ClientWebSocket` | `endHandler​(Handler<Void> endHandler)` | Set an end handler.
    `boolean` | `equals​(Object o)` |
    `ClientWebSocket` | `exceptionHandler​(Handler<Throwable> handler)` | Set an exception handler on the read stream.
    `ClientWebSocket` | `fetch​(long amount)` | Fetch the specified `amount` of elements.
    `ClientWebSocket` | `frameHandler​(Handler<WebSocketFrame> handler)` | Set a frame handler on the connection.
    `ClientWebSocket` | `getDelegate()` |
    `ClientWebSocket` | `handler​(Handler<Buffer> handler)` | Set a data handler.
    `int` | `hashCode()` |
    `MultiMap` | `headers()` | Returns the HTTP headers.
    `boolean` | `isClosed()` |
    `boolean` | `isSsl()` |
    `SocketAddress` | `localAddress()` |
    `static ClientWebSocket` | `newInstance​(ClientWebSocket arg)` |
    `ClientWebSocket` | `pause()` | Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `Pipe<Buffer>` | `pipe()` | Pause this stream and return a to transfer the elements of this stream to a destination .
    `Future<Void>` | `pipeTo​(WriteStream<Buffer> dst)` | Pipe this `ReadStream` to the `WriteStream`.
    `ClientWebSocket` | `pongHandler​(Handler<Buffer> handler)` | Set a pong frame handler on the connection.
    `SocketAddress` | `remoteAddress()` |
    `ClientWebSocket` | `resume()` | Resume reading, and sets the buffer in `flowing` mode.
    `Completable` | `rxClose()` | Close the WebSocket sending the default close frame.
    `Completable` | `rxClose​(short statusCode)` | Close the WebSocket sending a close frame with specified status code.
    `Completable` | `rxClose​(short statusCode, String reason)` | Close sending a close frame with specified status code and reason.
    `Single<WebSocket>` | `rxConnect​(int port, String host, String requestURI)` | Connect this WebSocket to the specified port, host and relative request URI.
    `Single<WebSocket>` | `rxConnect​(WebSocketConnectOptions options)` | Connect this WebSocket with the specified options.
    `Single<WebSocket>` | `rxConnect​(String requestURI)` | Connect this WebSocket at the relative request URI using the default host and port.
    `Single<WebSocket>` | `rxConnect​(String host, String requestURI)` | Connect this WebSocket to the host and relative request URI and default port.
    `Completable` | `rxEnd()` | Calls `WebSocketBase.close()`
    `Completable` | `rxEnd​(Buffer data)` | Same as `WebSocketBase.end(io.vertx.core.buffer.Buffer)` but writes some data to the stream before ending.
    `Completable` | `rxPipeTo​(WriteStream<Buffer> dst)` | Pipe this `ReadStream` to the `WriteStream`.
    `Completable` | `rxShutdown()` | Like `WebSocketBase.shutdown()` with a 30 seconds timeout, the status code `1000` a `null` reason.
    `Completable` | `rxShutdown​(long timeout, TimeUnit unit)` | Calls `WebSocketBase.shutdown()` with the status code `1000` and a `null` reason.
    `Completable` | `rxShutdown​(long timeout, TimeUnit unit, short statusCode)` | Calls `WebSocketBase.shutdown()` with a `null` reason.
    `Completable` | `rxShutdown​(long timeout, TimeUnit unit, short statusCode, String reason)` | Initiate a graceful WebSocket shutdown, the shutdown handler is notified and shall close the WebSocket, otherwise after a `timeout` the WebSocket will be closed.
    `Completable` | `rxShutdown​(short statusCode)` | Like `WebSocketBase.shutdown()` with a 30 seconds timeout and a `null` reason.
    `Completable` | `rxShutdown​(short statusCode, String reason)` | Like `WebSocketBase.shutdown()` with a 30 seconds timeout.
    `Completable` | `rxWrite​(Buffer data)` | Write some data to the stream.
    `Completable` | `rxWriteBinaryMessage​(Buffer data)` | Writes a (potentially large) piece of binary data to the connection.
    `Completable` | `rxWriteFinalBinaryFrame​(Buffer data)` | Write a final WebSocket binary frame to the connection
    `Completable` | `rxWriteFinalTextFrame​(String text)` | Write a final WebSocket text frame to the connection
    `Completable` | `rxWriteFrame​(WebSocketFrame frame)` | Write a WebSocket frame to the connection
    `Completable` | `rxWritePing​(Buffer data)` | Writes a ping frame to the connection.
    `Completable` | `rxWritePong​(Buffer data)` | Writes a pong frame to the connection.
    `Completable` | `rxWriteTextMessage​(String text)` | Writes a (potentially large) piece of text data to the connection.
    `ClientWebSocket` | `setWriteQueueMaxSize​(int maxSize)` | Set the maximum size of the write queue to `maxSize`.
    `Future<Void>` | `shutdown()` | Like `WebSocketBase.shutdown()` with a 30 seconds timeout, the status code `1000` a `null` reason.
    `Future<Void>` | `shutdown​(long timeout, TimeUnit unit)` | Calls `WebSocketBase.shutdown()` with the status code `1000` and a `null` reason.
    `Future<Void>` | `shutdown​(long timeout, TimeUnit unit, short statusCode)` | Calls `WebSocketBase.shutdown()` with a `null` reason.
    `Future<Void>` | `shutdown​(long timeout, TimeUnit unit, short statusCode, String reason)` | Initiate a graceful WebSocket shutdown, the shutdown handler is notified and shall close the WebSocket, otherwise after a `timeout` the WebSocket will be closed.
    `Future<Void>` | `shutdown​(short statusCode)` | Like `WebSocketBase.shutdown()` with a 30 seconds timeout and a `null` reason.
    `Future<Void>` | `shutdown​(short statusCode, String reason)` | Like `WebSocketBase.shutdown()` with a 30 seconds timeout.
    `SSLSession` | `sslSession()` |
    `String` | `subProtocol()` | Returns the WebSocket sub protocol selected by the WebSocket handshake.
    `String` | `textHandlerID()` | When a `WebSocket` is created, it may register an event handler with the eventbus, the ID of that handler is given by `textHandlerID`.
    `ClientWebSocket` | `textMessageHandler​(Handler<String> handler)` | Set a text message handler on the connection.
    `Flowable<Buffer>` | `toFlowable()` |
    `Observable<Buffer>` | `toObservable()` |
    `WriteStreamObserver<Buffer>` | `toObserver()` |
    `String` | `toString()` |
    `WriteStreamSubscriber<Buffer>` | `toSubscriber()` |
    `Future<Void>` | `write​(Buffer data)` | Write some data to the stream.
    `Future<Void>` | `writeBinaryMessage​(Buffer data)` | Writes a (potentially large) piece of binary data to the connection.
    `Future<Void>` | `writeFinalBinaryFrame​(Buffer data)` | Write a final WebSocket binary frame to the connection
    `Future<Void>` | `writeFinalTextFrame​(String text)` | Write a final WebSocket text frame to the connection
    `Future<Void>` | `writeFrame​(WebSocketFrame frame)` | Write a WebSocket frame to the connection
    `Future<Void>` | `writePing​(Buffer data)` | Writes a ping frame to the connection.
    `Future<Void>` | `writePong​(Buffer data)` | Writes a pong frame to the connection.
    `boolean` | `writeQueueFull()` | This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
    `Future<Void>` | `writeTextMessage​(String text)` | Writes a (potentially large) piece of text data to the connection.

    - ### Methods inherited from class io.vertx.reactivex.core.http.WebSocket

      `newInstance, shutdownHandler`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<ClientWebSocket> __TYPE_ARG

  - ### Constructor Detail

    - #### ClientWebSocket

          public ClientWebSocket​(ClientWebSocket delegate)

    - #### ClientWebSocket

          public ClientWebSocket​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `WebSocket`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `WebSocket`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `WebSocket`

    - #### getDelegate

          public ClientWebSocket getDelegate()

      Specified by:
        `getDelegate` in interface `ReadStream<Buffer>`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WebSocketBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`
      Overrides:
        `getDelegate` in class `WebSocket`

    - #### toObservable

          public Observable<Buffer> toObservable()

      Specified by:
        `toObservable` in interface `ReadStream<Buffer>`
      Overrides:
        `toObservable` in class `WebSocket`

    - #### toFlowable

          public Flowable<Buffer> toFlowable()

      Specified by:
        `toFlowable` in interface `ReadStream<Buffer>`
      Overrides:
        `toFlowable` in class `WebSocket`

    - #### toObserver

          public WriteStreamObserver<Buffer> toObserver()

      Specified by:
        `toObserver` in interface `WriteStream<Buffer>`
      Overrides:
        `toObserver` in class `WebSocket`

    - #### toSubscriber

          public WriteStreamSubscriber<Buffer> toSubscriber()

      Specified by:
        `toSubscriber` in interface `WriteStream<Buffer>`
      Overrides:
        `toSubscriber` in class `WebSocket`

    - #### pipe

          public Pipe<Buffer> pipe()

      Pause this stream and return a to transfer the elements of this stream to a destination .

      The stream will be resumed when the pipe will be wired to a `WriteStream`.
      Specified by:
        `pipe` in interface `ReadStream<Buffer>`
      Specified by:
        `pipe` in interface `WebSocketBase`
      Overrides:
        `pipe` in class `WebSocket`
      Returns:
        a pipe

    - #### pipeTo

          public Future<Void> pipeTo​(WriteStream<Buffer> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Specified by:
        `pipeTo` in interface `ReadStream<Buffer>`
      Specified by:
        `pipeTo` in interface `WebSocketBase`
      Overrides:
        `pipeTo` in class `WebSocket`
      Parameters:
        `dst` - the destination write stream
      Returns:
        a future notified when the write stream will be ended with the outcome

    - #### rxPipeTo

          public Completable rxPipeTo​(WriteStream<Buffer> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Specified by:
        `rxPipeTo` in interface `ReadStream<Buffer>`
      Specified by:
        `rxPipeTo` in interface `WebSocketBase`
      Overrides:
        `rxPipeTo` in class `WebSocket`
      Parameters:
        `dst` - the destination write stream
      Returns:
        a future notified when the write stream will be ended with the outcome

    - #### write

          public Future<Void> write​(Buffer data)

      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a .

      When the `data` is moved from the queue to the actual medium, the returned will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `write` in interface `WebSocketBase`
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Overrides:
        `write` in class `WebSocket`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### rxWrite

          public Completable rxWrite​(Buffer data)

      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a .

      When the `data` is moved from the queue to the actual medium, the returned will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `rxWrite` in interface `WebSocketBase`
      Specified by:
        `rxWrite` in interface `WriteStream<Buffer>`
      Overrides:
        `rxWrite` in class `WebSocket`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### end

          public Future<Void> end​(Buffer data)

      Same as `WebSocketBase.end(io.vertx.core.buffer.Buffer)` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WebSocketBase`
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Overrides:
        `end` in class `WebSocket`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### rxEnd

          public Completable rxEnd​(Buffer data)

      Same as `WebSocketBase.end(io.vertx.core.buffer.Buffer)` but writes some data to the stream before ending.
      Specified by:
        `rxEnd` in interface `WebSocketBase`
      Specified by:
        `rxEnd` in interface `WriteStream<Buffer>`
      Overrides:
        `rxEnd` in class `WebSocket`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WebSocketBase`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Overrides:
        `writeQueueFull` in class `WebSocket`
      Returns:
        `true` if write queue is full

    - #### binaryHandlerID

          public String binaryHandlerID()

      When a `WebSocket` is created, it may register an event handler with the event bus - the ID of that handler is given by this method.

      By default, no handler is registered, the feature must be enabled via `WebSocketConnectOptions` or `HttpServerOptions`.

      Given this ID, a different event loop can send a binary frame to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other WebSockets which are owned by different event loops.

      Specified by:
        `binaryHandlerID` in interface `WebSocketBase`
      Overrides:
        `binaryHandlerID` in class `WebSocket`
      Returns:
        the binary handler id

    - #### textHandlerID

          public String textHandlerID()

      When a `WebSocket` is created, it may register an event handler with the eventbus, the ID of that handler is given by `textHandlerID`.

      By default, no handler is registered, the feature must be enabled via `WebSocketConnectOptions` or `HttpServerOptions`.

      Given this ID, a different event loop can send a text frame to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other WebSockets which are owned by different event loops.

      Specified by:
        `textHandlerID` in interface `WebSocketBase`
      Overrides:
        `textHandlerID` in class `WebSocket`
      Returns:
        the text handler id

    - #### subProtocol

          public String subProtocol()

      Returns the WebSocket sub protocol selected by the WebSocket handshake.

      On the server, the value will be `null` when the handler receives the WebSocket callback as the handshake will not be completed yet.
      Specified by:
        `subProtocol` in interface `WebSocketBase`
      Overrides:
        `subProtocol` in class `WebSocket`
      Returns:

    - #### closeStatusCode

          public Short closeStatusCode()

      Returns the close status code received from the remote endpoint or `null` when not yet received.
      Specified by:
        `closeStatusCode` in interface `WebSocketBase`
      Overrides:
        `closeStatusCode` in class `WebSocket`
      Returns:

    - #### closeReason

          public String closeReason()

      Returns the close reason message from the remote endpoint or `null` when not yet received.
      Specified by:
        `closeReason` in interface `WebSocketBase`
      Overrides:
        `closeReason` in class `WebSocket`
      Returns:

    - #### headers

          public MultiMap headers()

      Returns the HTTP headers.
      Specified by:
        `headers` in interface `WebSocketBase`
      Overrides:
        `headers` in class `WebSocket`
      Returns:
        the headers

    - #### writeFrame

          public Future<Void> writeFrame​(WebSocketFrame frame)

      Write a WebSocket frame to the connection
      Specified by:
        `writeFrame` in interface `WebSocketBase`
      Overrides:
        `writeFrame` in class `WebSocket`
      Parameters:
        `frame` - the frame to write
      Returns:
        a future completed with the result

    - #### rxWriteFrame

          public Completable rxWriteFrame​(WebSocketFrame frame)

      Write a WebSocket frame to the connection
      Specified by:
        `rxWriteFrame` in interface `WebSocketBase`
      Overrides:
        `rxWriteFrame` in class `WebSocket`
      Parameters:
        `frame` - the frame to write
      Returns:
        a future completed with the result

    - #### writeFinalTextFrame

          public Future<Void> writeFinalTextFrame​(String text)

      Write a final WebSocket text frame to the connection
      Specified by:
        `writeFinalTextFrame` in interface `WebSocketBase`
      Overrides:
        `writeFinalTextFrame` in class `WebSocket`
      Parameters:
        `text` - The text to write
      Returns:
        a future completed with the result

    - #### rxWriteFinalTextFrame

          public Completable rxWriteFinalTextFrame​(String text)

      Write a final WebSocket text frame to the connection
      Specified by:
        `rxWriteFinalTextFrame` in interface `WebSocketBase`
      Overrides:
        `rxWriteFinalTextFrame` in class `WebSocket`
      Parameters:
        `text` - The text to write
      Returns:
        a future completed with the result

    - #### writeFinalBinaryFrame

          public Future<Void> writeFinalBinaryFrame​(Buffer data)

      Write a final WebSocket binary frame to the connection
      Specified by:
        `writeFinalBinaryFrame` in interface `WebSocketBase`
      Overrides:
        `writeFinalBinaryFrame` in class `WebSocket`
      Parameters:
        `data` - The data to write
      Returns:
        a future completed with the result

    - #### rxWriteFinalBinaryFrame

          public Completable rxWriteFinalBinaryFrame​(Buffer data)

      Write a final WebSocket binary frame to the connection
      Specified by:
        `rxWriteFinalBinaryFrame` in interface `WebSocketBase`
      Overrides:
        `rxWriteFinalBinaryFrame` in class `WebSocket`
      Parameters:
        `data` - The data to write
      Returns:
        a future completed with the result

    - #### writeBinaryMessage

          public Future<Void> writeBinaryMessage​(Buffer data)

      Writes a (potentially large) piece of binary data to the connection. This data might be written as multiple frames if it exceeds the maximum WebSocket frame size.
      Specified by:
        `writeBinaryMessage` in interface `WebSocketBase`
      Overrides:
        `writeBinaryMessage` in class `WebSocket`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### rxWriteBinaryMessage

          public Completable rxWriteBinaryMessage​(Buffer data)

      Writes a (potentially large) piece of binary data to the connection. This data might be written as multiple frames if it exceeds the maximum WebSocket frame size.
      Specified by:
        `rxWriteBinaryMessage` in interface `WebSocketBase`
      Overrides:
        `rxWriteBinaryMessage` in class `WebSocket`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### writeTextMessage

          public Future<Void> writeTextMessage​(String text)

      Writes a (potentially large) piece of text data to the connection. This data might be written as multiple frames if it exceeds the maximum WebSocket frame size.
      Specified by:
        `writeTextMessage` in interface `WebSocketBase`
      Overrides:
        `writeTextMessage` in class `WebSocket`
      Parameters:
        `text` - the data to write
      Returns:
        a future completed with the result

    - #### rxWriteTextMessage

          public Completable rxWriteTextMessage​(String text)

      Writes a (potentially large) piece of text data to the connection. This data might be written as multiple frames if it exceeds the maximum WebSocket frame size.
      Specified by:
        `rxWriteTextMessage` in interface `WebSocketBase`
      Overrides:
        `rxWriteTextMessage` in class `WebSocket`
      Parameters:
        `text` - the data to write
      Returns:
        a future completed with the result

    - #### writePing

          public Future<Void> writePing​(Buffer data)

      Writes a ping frame to the connection. This will be written in a single frame. Ping frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 Section section 5.5.2.

      There is no handler for ping frames because RFC 6455 clearly states that the only response to a ping frame is a pong frame with identical contents.

      Specified by:
        `writePing` in interface `WebSocketBase`
      Overrides:
        `writePing` in class `WebSocket`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
      Returns:
        a future notified when the ping frame has been successfully written

    - #### rxWritePing

          public Completable rxWritePing​(Buffer data)

      Writes a ping frame to the connection. This will be written in a single frame. Ping frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 Section section 5.5.2.

      There is no handler for ping frames because RFC 6455 clearly states that the only response to a ping frame is a pong frame with identical contents.

      Specified by:
        `rxWritePing` in interface `WebSocketBase`
      Overrides:
        `rxWritePing` in class `WebSocket`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
      Returns:
        a future notified when the ping frame has been successfully written

    - #### writePong

          public Future<Void> writePong​(Buffer data)

      Writes a pong frame to the connection. This will be written in a single frame. Pong frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 section 5.5.2.

      There is no need to manually write a pong frame, as the server and client both handle responding to a ping from with a pong from automatically and this is exposed to users. RFC 6455 section 5.5.3 states that pongs may be sent unsolicited in order to implement a one way heartbeat.

      Specified by:
        `writePong` in interface `WebSocketBase`
      Overrides:
        `writePong` in class `WebSocket`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
      Returns:
        a future notified when the pong frame has been successfully written

    - #### rxWritePong

          public Completable rxWritePong​(Buffer data)

      Writes a pong frame to the connection. This will be written in a single frame. Pong frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 section 5.5.2.

      There is no need to manually write a pong frame, as the server and client both handle responding to a ping from with a pong from automatically and this is exposed to users. RFC 6455 section 5.5.3 states that pongs may be sent unsolicited in order to implement a one way heartbeat.

      Specified by:
        `rxWritePong` in interface `WebSocketBase`
      Overrides:
        `rxWritePong` in class `WebSocket`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
      Returns:
        a future notified when the pong frame has been successfully written

    - #### end

          public Future<Void> end()

      Calls `WebSocketBase.close()`
      Specified by:
        `end` in interface `WebSocketBase`
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Overrides:
        `end` in class `WebSocket`
      Returns:

    - #### rxEnd

          public Completable rxEnd()

      Calls `WebSocketBase.close()`
      Specified by:
        `rxEnd` in interface `WebSocketBase`
      Specified by:
        `rxEnd` in interface `WriteStream<Buffer>`
      Overrides:
        `rxEnd` in class `WebSocket`
      Returns:

    - #### close

          public Future<Void> close()

      Close the WebSocket sending the default close frame.

      No more messages can be sent.
      Specified by:
        `close` in interface `WebSocketBase`
      Overrides:
        `close` in class `WebSocket`
      Returns:
        a future completed with the result

    - #### rxClose

          public Completable rxClose()

      Close the WebSocket sending the default close frame.

      No more messages can be sent.
      Specified by:
        `rxClose` in interface `WebSocketBase`
      Overrides:
        `rxClose` in class `WebSocket`
      Returns:
        a future completed with the result

    - #### close

          public Future<Void> close​(short statusCode)

      Close the WebSocket sending a close frame with specified status code. You can give a look at various close payloads here: RFC6455 section 7.4.1

      No more messages can be sent.
      Specified by:
        `close` in interface `WebSocketBase`
      Overrides:
        `close` in class `WebSocket`
      Parameters:
        `statusCode` - the status code
      Returns:
        a future completed with the result

    - #### rxClose

          public Completable rxClose​(short statusCode)

      Close the WebSocket sending a close frame with specified status code. You can give a look at various close payloads here: RFC6455 section 7.4.1

      No more messages can be sent.
      Specified by:
        `rxClose` in interface `WebSocketBase`
      Overrides:
        `rxClose` in class `WebSocket`
      Parameters:
        `statusCode` - the status code
      Returns:
        a future completed with the result

    - #### close

          public Future<Void> close​(short statusCode,
                                    String reason)

      Close sending a close frame with specified status code and reason. You can give a look at various close payloads here: RFC6455 section 7.4.1

      No more messages can be sent.
      Specified by:
        `close` in interface `WebSocketBase`
      Overrides:
        `close` in class `WebSocket`
      Parameters:
        `statusCode` - the status code
        `reason` - reason of closure
      Returns:
        a future completed with the result

    - #### rxClose

          public Completable rxClose​(short statusCode,
                                     String reason)

      Close sending a close frame with specified status code and reason. You can give a look at various close payloads here: RFC6455 section 7.4.1

      No more messages can be sent.
      Specified by:
        `rxClose` in interface `WebSocketBase`
      Overrides:
        `rxClose` in class `WebSocket`
      Parameters:
        `statusCode` - the status code
        `reason` - reason of closure
      Returns:
        a future completed with the result

    - #### shutdown

          public Future<Void> shutdown()

      Like `WebSocketBase.shutdown()` with a 30 seconds timeout, the status code `1000` a `null` reason.
      Specified by:
        `shutdown` in interface `WebSocketBase`
      Overrides:
        `shutdown` in class `WebSocket`
      Returns:

    - #### rxShutdown

          public Completable rxShutdown()

      Like `WebSocketBase.shutdown()` with a 30 seconds timeout, the status code `1000` a `null` reason.
      Specified by:
        `rxShutdown` in interface `WebSocketBase`
      Overrides:
        `rxShutdown` in class `WebSocket`
      Returns:

    - #### shutdown

          public Future<Void> shutdown​(short statusCode)

      Like `WebSocketBase.shutdown()` with a 30 seconds timeout and a `null` reason.
      Specified by:
        `shutdown` in interface `WebSocketBase`
      Overrides:
        `shutdown` in class `WebSocket`
      Parameters:
        `statusCode` -
      Returns:

    - #### rxShutdown

          public Completable rxShutdown​(short statusCode)

      Like `WebSocketBase.shutdown()` with a 30 seconds timeout and a `null` reason.
      Specified by:
        `rxShutdown` in interface `WebSocketBase`
      Overrides:
        `rxShutdown` in class `WebSocket`
      Parameters:
        `statusCode` -
      Returns:

    - #### shutdown

          public Future<Void> shutdown​(short statusCode,
                                       String reason)

      Like `WebSocketBase.shutdown()` with a 30 seconds timeout.
      Specified by:
        `shutdown` in interface `WebSocketBase`
      Overrides:
        `shutdown` in class `WebSocket`
      Parameters:
        `statusCode` -
        `reason` -
      Returns:

    - #### rxShutdown

          public Completable rxShutdown​(short statusCode,
                                        String reason)

      Like `WebSocketBase.shutdown()` with a 30 seconds timeout.
      Specified by:
        `rxShutdown` in interface `WebSocketBase`
      Overrides:
        `rxShutdown` in class `WebSocket`
      Parameters:
        `statusCode` -
        `reason` -
      Returns:

    - #### shutdown

          public Future<Void> shutdown​(long timeout,
                                       TimeUnit unit)

      Calls `WebSocketBase.shutdown()` with the status code `1000` and a `null` reason.
      Specified by:
        `shutdown` in interface `WebSocketBase`
      Overrides:
        `shutdown` in class `WebSocket`
      Parameters:
        `timeout` -
        `unit` -
      Returns:

    - #### rxShutdown

          public Completable rxShutdown​(long timeout,
                                        TimeUnit unit)

      Calls `WebSocketBase.shutdown()` with the status code `1000` and a `null` reason.
      Specified by:
        `rxShutdown` in interface `WebSocketBase`
      Overrides:
        `rxShutdown` in class `WebSocket`
      Parameters:
        `timeout` -
        `unit` -
      Returns:

    - #### shutdown

          public Future<Void> shutdown​(long timeout,
                                       TimeUnit unit,
                                       short statusCode)

      Calls `WebSocketBase.shutdown()` with a `null` reason.
      Specified by:
        `shutdown` in interface `WebSocketBase`
      Overrides:
        `shutdown` in class `WebSocket`
      Parameters:
        `timeout` -
        `unit` -
        `statusCode` -
      Returns:

    - #### rxShutdown

          public Completable rxShutdown​(long timeout,
                                        TimeUnit unit,
                                        short statusCode)

      Calls `WebSocketBase.shutdown()` with a `null` reason.
      Specified by:
        `rxShutdown` in interface `WebSocketBase`
      Overrides:
        `rxShutdown` in class `WebSocket`
      Parameters:
        `timeout` -
        `unit` -
        `statusCode` -
      Returns:

    - #### shutdown

          public Future<Void> shutdown​(long timeout,
                                       TimeUnit unit,
                                       short statusCode,
                                       String reason)

      Initiate a graceful WebSocket shutdown, the shutdown handler is notified and shall close the WebSocket, otherwise after a `timeout` the WebSocket will be closed.

      The WebSocket is closed with specified status code and reason. You can give a look at various close payloads here: RFC6455 section 7.4.1
      Specified by:
        `shutdown` in interface `WebSocketBase`
      Overrides:
        `shutdown` in class `WebSocket`
      Parameters:
        `timeout` - the amount of time after which all resources are forcibly closed
        `unit` - the of the timeout
        `statusCode` - the status code
        `reason` - reason of closure
      Returns:
        a future completed when shutdown has completed

    - #### rxShutdown

          public Completable rxShutdown​(long timeout,
                                        TimeUnit unit,
                                        short statusCode,
                                        String reason)

      Initiate a graceful WebSocket shutdown, the shutdown handler is notified and shall close the WebSocket, otherwise after a `timeout` the WebSocket will be closed.

      The WebSocket is closed with specified status code and reason. You can give a look at various close payloads here: RFC6455 section 7.4.1
      Specified by:
        `rxShutdown` in interface `WebSocketBase`
      Overrides:
        `rxShutdown` in class `WebSocket`
      Parameters:
        `timeout` - the amount of time after which all resources are forcibly closed
        `unit` - the of the timeout
        `statusCode` - the status code
        `reason` - reason of closure
      Returns:
        a future completed when shutdown has completed

    - #### remoteAddress

          public SocketAddress remoteAddress()

      Specified by:
        `remoteAddress` in interface `WebSocketBase`
      Overrides:
        `remoteAddress` in class `WebSocket`
      Returns:
        the remote address for this connection, possibly `null` (e.g a server bound on a domain socket). If `useProxyProtocol` is set to `true`, the address returned will be of the actual connecting client.

    - #### localAddress

          public SocketAddress localAddress()

      Specified by:
        `localAddress` in interface `WebSocketBase`
      Overrides:
        `localAddress` in class `WebSocket`
      Returns:
        the local address for this connection, possibly `null` (e.g a server bound on a domain socket) If `useProxyProtocol` is set to `true`, the address returned will be of the proxy.

    - #### isSsl

          public boolean isSsl()

      Specified by:
        `isSsl` in interface `WebSocketBase`
      Overrides:
        `isSsl` in class `WebSocket`
      Returns:
        true if this `HttpConnection` is encrypted via SSL/TLS.

    - #### isClosed

          public boolean isClosed()

      Specified by:
        `isClosed` in interface `WebSocketBase`
      Overrides:
        `isClosed` in class `WebSocket`
      Returns:
        `true` if the WebSocket cannot be used to send message anymore

    - #### connect

          public Future<WebSocket> connect​(WebSocketConnectOptions options)

      Connect this WebSocket with the specified options.
      Parameters:
        `options` - the request options
      Returns:
        a future notified when the WebSocket when connected

    - #### rxConnect

          public Single<WebSocket> rxConnect​(WebSocketConnectOptions options)

      Connect this WebSocket with the specified options.
      Parameters:
        `options` - the request options
      Returns:
        a future notified when the WebSocket when connected

    - #### connect

          public Future<WebSocket> connect​(int port,
                                           String host,
                                           String requestURI)

      Connect this WebSocket to the specified port, host and relative request URI.
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
      Returns:
        a future notified when the WebSocket when connected

    - #### rxConnect

          public Single<WebSocket> rxConnect​(int port,
                                             String host,
                                             String requestURI)

      Connect this WebSocket to the specified port, host and relative request URI.
      Parameters:
        `port` - the port
        `host` - the host
        `requestURI` - the relative URI
      Returns:
        a future notified when the WebSocket when connected

    - #### connect

          public Future<WebSocket> connect​(String host,
                                           String requestURI)

      Connect this WebSocket to the host and relative request URI and default port.
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
      Returns:
        a future notified when the WebSocket when connected

    - #### rxConnect

          public Single<WebSocket> rxConnect​(String host,
                                             String requestURI)

      Connect this WebSocket to the host and relative request URI and default port.
      Parameters:
        `host` - the host
        `requestURI` - the relative URI
      Returns:
        a future notified when the WebSocket when connected

    - #### connect

          public Future<WebSocket> connect​(String requestURI)

      Connect this WebSocket at the relative request URI using the default host and port.
      Parameters:
        `requestURI` - the relative URI
      Returns:
        a future notified when the WebSocket when connected

    - #### rxConnect

          public Single<WebSocket> rxConnect​(String requestURI)

      Connect this WebSocket at the relative request URI using the default host and port.
      Parameters:
        `requestURI` - the relative URI
      Returns:
        a future notified when the WebSocket when connected

    - #### pause

          public ClientWebSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Specified by:
        `pause` in interface `WebSocketBase`
      Overrides:
        `pause` in class `WebSocket`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          public ClientWebSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Specified by:
        `resume` in interface `WebSocketBase`
      Overrides:
        `resume` in class `WebSocket`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          public ClientWebSocket fetch​(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Specified by:
        `fetch` in interface `WebSocketBase`
      Overrides:
        `fetch` in class `WebSocket`
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          public ClientWebSocket setWriteQueueMaxSize​(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WebSocketBase`
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Overrides:
        `setWriteQueueMaxSize` in class `WebSocket`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          public ClientWebSocket handler​(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Specified by:
        `handler` in interface `WebSocketBase`
      Overrides:
        `handler` in class `WebSocket`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          public ClientWebSocket endHandler​(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `endHandler` in interface `WebSocketBase`
      Overrides:
        `endHandler` in class `WebSocket`
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public ClientWebSocket drainHandler​(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WebSocketBase`
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Overrides:
        `drainHandler` in class `WebSocket`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### closeHandler

          public ClientWebSocket closeHandler​(Handler<Void> handler)

      Description copied from interface: `WebSocketBase`
      Set a close handler. This will be called when the WebSocket is closed.

      After this callback, no more messages are expected. When the WebSocket received a close frame, the `WebSocketBase.closeStatusCode()` will return the status code and `WebSocketBase.closeReason()` will return the reason.
      Specified by:
        `closeHandler` in interface `WebSocketBase`
      Overrides:
        `closeHandler` in class `WebSocket`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### frameHandler

          public ClientWebSocket frameHandler​(Handler<WebSocketFrame> handler)

      Description copied from interface: `WebSocketBase`
      Set a frame handler on the connection. This handler will be called when frames are read on the connection.
      Specified by:
        `frameHandler` in interface `WebSocketBase`
      Overrides:
        `frameHandler` in class `WebSocket`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### textMessageHandler

          public ClientWebSocket textMessageHandler​(Handler<String> handler)

      Description copied from interface: `WebSocketBase`
      Set a text message handler on the connection. This handler will be called similar to the `WebSocketBase.binaryMessageHandler(io.vertx.core.Handler<io.vertx.core.buffer.Buffer>)`, but the buffer will be converted to a String first
      Specified by:
        `textMessageHandler` in interface `WebSocketBase`
      Overrides:
        `textMessageHandler` in class `WebSocket`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### binaryMessageHandler

          public ClientWebSocket binaryMessageHandler​(Handler<Buffer> handler)

      Description copied from interface: `WebSocketBase`
      Set a binary message handler on the connection. This handler serves a similar purpose to `WebSocketBase.handler(io.vertx.core.Handler<io.vertx.core.buffer.Buffer>)` except that if a message comes into the socket in multiple frames, the data from the frames will be aggregated into a single buffer before calling the handler (using `WebSocketFrame` to find the boundaries).
      Specified by:
        `binaryMessageHandler` in interface `WebSocketBase`
      Overrides:
        `binaryMessageHandler` in class `WebSocket`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### pongHandler

          public ClientWebSocket pongHandler​(Handler<Buffer> handler)

      Description copied from interface: `WebSocketBase`
      Set a pong frame handler on the connection. This handler will be invoked every time a pong frame is received on the server, and can be used by both clients and servers since the RFC 6455 section 5.5.2 and section 5.5.3 do not specify whether the client or server sends a ping.

      Pong frames may be at most 125 bytes (octets).

      There is no ping handler since ping frames should immediately be responded to with a pong frame with identical content

      Pong frames may be received unsolicited.

      Specified by:
        `pongHandler` in interface `WebSocketBase`
      Overrides:
        `pongHandler` in class `WebSocket`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### exceptionHandler

          public ClientWebSocket exceptionHandler​(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WebSocketBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Overrides:
        `exceptionHandler` in class `WebSocket`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### sslSession

          public SSLSession sslSession()

      Overrides:
        `sslSession` in class `WebSocket`
      Returns:
        SSLSession associated with the underlying socket. Returns null if connection is not SSL.

    - #### newInstance

          public static ClientWebSocket newInstance​(ClientWebSocket arg)